﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HEAL.Attic;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;

namespace HeuristicLab.Problems.DataAnalysis.Symbolic{
  [StorableType("C94A360D-5A9F-48A3-A6D3-CF920C77E50D")]
  public interface IBoundsEstimator : INamedItem, IStatefulItem {
    Interval GetModelBound(ISymbolicExpressionTree tree, IntervalCollection variableRanges);

    IDictionary<ISymbolicExpressionTreeNode, Interval> GetModelNodesBounds(
      ISymbolicExpressionTree tree, IntervalCollection variableRanges);

    double CheckConstraint(
      ISymbolicExpressionTree tree, IntervalCollection variableRanges, IntervalConstraint constraint);

    bool IsCompatible(ISymbolicExpressionTree tree);

    int EvaluatedSolutions { get; set; }
    }
}